E1oM20.R GISS Model E  coupled version          larissa   01/22/2009

E1oM20: 4x5x20 layers modelE version, 1880 atm.; 13 layers in the ocean

E1oM20: replace this section by a description of what distinguishes this run ?
       Use as many lines as you need. Look carefully at all the possible    ?
       choices, particularly the lines containing '?'. In some cases, you   ?
       will have to pick the appropriate choice to make this rundeck work   ?
       The final rundeck should contain no '?'
       Check and modify the rest of the description below:                  ?
modelE1 (3.0) 4x5 hor. grid with 20 lyrs, top at .1 mb (+ 3 rad.lyrs)       ?
atmospheric composition from year 1880 ? 1979                               ?
ocean: coupled to GISS ocean model (Russell - Schmidt)                      ?
uses turbulence scheme (no dry conv), simple strat.drag (no grav.wave drag) ?
time steps: dynamics 7.5 min leap frog; physics 30 min.; radiation 2.5 hrs  ?
filters: U,V in E-W direction (after every dynamics time step)              ?
         sea level pressure (after every physics time step)                 ?

Preprocessor Options
!#define TRACERS_ON                  ! include tracers code
#define USE_ENT
#define NEW_IO
#define CHECK_OCEAN                 ! needed to compile aux/file CMPE002
End Preprocessor Options

Object modules: (in order of decreasing priority)
       ! resolution-specific source codes
Atm72x46                   ! horizontal resolution is 72x46 -> 4x5deg
AtmL20 STRAT_DUM          ! vertical resolution is 20 layers -> 0.1mb
DIAG_RES_M  
ORES_5x4_L13                ! ocean horiz res 4x5deg, 13 vert layers
FFT72                      ! Fast Fourier Transform

IO_DRV                             ! new i/o

     ! GISS dynamics w/o gravity wave drag
ATMDYN MOMEN2ND                     ! atmospheric dynamics
QUS_DRV QUS3D

#include "latlon_source_files"
#include "planet_source_files"

ODIAG_COM OCEAN_COM OSTRAITS_COM OGEOM   ! dynamic ocean modules
OCNDYN OCNDYN2                           ! dynamic ocean routines
OCNGISSVM
OCN_Interp OCN_Int_LATLON                ! dynamic ocean routines
OSTRAITS OCNGM OCNKPP                    ! dynamic ocean routines
OCEANR_DIM OFLUXES
ODIAG_PRT                              ! ocean diagnostic print out
OCNFUNTAB                           ! ocean function look up table
OCNQUS                     ! QUS advection scheme
OFFT72E                 ! utilities
SparseCommunicator_mod              ! sparse gather/scatter module

Components:
#include "E4_components_nc"    /* without "Ent" */
Ent

Component Options:
OPTS_Ent = ONLINE=YES PS_MODEL=FBB    /* needed for "Ent" only */
OPTS_giss_LSM = USE_ENT=YES           /* needed for "Ent" only */

Data input files:
#include "IC_72x46_input_files"
OIC=OIC4X5LD.Z12.gas1.CLEV94.DEC01.nc ! ocean initial conditions
OFTAB=OFTABLE_NEW                    ! ocean function table
KBASIN=KB4X513.OCN.gas1.nc           ! ocean basin designations
TOPO=Z72X46N_gas.1_nocasp.nc
TOPO_OC=OZ72X46N_gas.1_nocasp.nc     ! ocean bdy.cond
OSTRAITS=OSTRAITS_72x46.nml          ! parameterized straits info

RVR=RD_modelE_M.nc                ! river direction file
NAMERVR=RD_modelE_M.names.txt     ! named river outlets

#include "land72x46_input_files"
#include "rad_input_files"
#include "rad_72x46_input_files"

MSU_wts=MSU.RSS.weights.data
REG=REG4X5                      ! special regions-diag

Label and Namelist:
E1oM20 (1880 atm.,the current modelE version)

DTFIX=300
&&PARAMETERS
! parameters set for coupled ocean runs:
KOCEAN=1        ! ocn is prognostic
variable_lk=1   ! Variable lakes on

! parameters usually not changed when switching to coupled ocean:

#include "sdragM20_params"

PTLISO=15.  ! press(mb) above which rad. assumes isothermal layers

xCDpbl=1.
cond_scheme=2    ! more elaborate conduction scheme (GHY, Nancy Kiang)

! Tuning parameters as of 2017/04/26 (D.S. Amundsen) - should be revisited
U00a=.50    ! above 850mb w/o MC region; tune this first to get 30-35% high clouds
U00b=1.30   ! below 850mb and MC regions; then tune this to get rad.balance
radiusl_multiplier=0.8
wmui_multiplier=0.1

CO2X=1.
H2OstratX=1.

H2ObyCH4=1.     ! activates strat.H2O generated by CH4
KSIALB=0        ! 6-band albedo (Hansen) (=1 A.Lacis orig. 6-band alb)
KSOLAR=2

#include "atmCompos_1850_params"
madaer=3         ! 3: updated aerosols          ; 1: default sulfates/aerosols
aer_rad_forc=0
cloud_rad_forc=1

! parameters that control the Shapiro filter
DT_XUfilter=450. ! Shapiro filter on U in E-W direction; usually same as DT (below)
DT_XVfilter=450. ! Shapiro filter on V in E-W direction; usually same as DT (below)
DT_YVfilter=0.   ! Shapiro filter on V in N-S direction
DT_YUfilter=0.   ! Shapiro filter on U in N-S direction

! Orbit parameters that have different defaults for Earth and not-Earth
! EOT = 'F' for Earth
! EOT = 'T' for not-Earth

! parameters that may have to be changed in emergencies:
DTsrc=1800.
DT=450.
NIsurf=1        ! increase as layer 1 gets thinner

#include "diag_params"

Nssw=2           ! until diurnal diags are fixed, Nssw has to be even
Ndisk=480
&&END_PARAMETERS

 &INPUTZ
 YEARI=1900,MONTHI=12,DATEI=1,HOURI=0, ! pick IYEAR1=YEARI (default) or < YEARI
 YEARE=1900,MONTHE=12,DATEE=2,HOURE=0, KDIAG=13*0,
 ISTART=2,IRANDI=0, YEARE=1900,MONTHE=12,DATEE=1,HOURE=1,IWRITE=1,JWRITE=1,
/


