E4arobio_h.R GISS Model E  coupled version          natassa   10/18/2010

E_AR5_NINT_oH.R GISS Model E  coupled version          tnl   10/12/2010
E_AR5_NINT_oH: E4F40 coupled to 1x1deg 26-layer Hybrid-Isopycnal Coordinate Ocean Model (HYCOM)
               + WMUI_multiplier=2. (to adjust Planetary albedo close to 30%) 
                 (U00a=0.54; U00b=1.0)

E_AR5_NINT_oH : sibling E_AR5_NINT_oR
modelE1 (3.0) 2x2.5 hor. grid with 40 lyrs, top at .1 mb (+ 3 rad.lyrs)
atmospheric composition from year 1850
ocean: coupled to 1x1deg 26-layer HYCOM
uses turbulence scheme (no dry conv), grav.wave drag
time steps: dynamics 3.75 min leap frog; physics 30 min.; radiation 2.5 hrs
filters: U,V in E-W and N-S direction (after every physics time step)
         U,V in E-W direction near poles (after every dynamics time step)
         sea level pressure (after every physics time step)

Preprocessor Options
#define USE_ENT
#define NEW_IO
#define CHECK_OCEAN                  ! needed to compile aux/file CMPE002
#define ATM2x2h                      ! 2x2.5 40 layer atm
#define HYCOM1deg                    ! 1deg 26 layer hycom (387x360x26)
#define TRACERS_OceanBiology
#define OBIO_RAD_coupling
#define pCO2_ONLINE
! #define constCO2
#define TRACERS_ON                  ! include tracers code
#define TRACERS_GASEXCH_ocean       ! ANY ocean: special tracers to be passed to ocean
#define TRACERS_GASEXCH_ocean_CO2   ! ANY ocean: special tracers to be passed to ocean
! #define TRACERS_HYCOM_Ventilation
!!!!#define change_PNOICE           ! adjust ice-obio interactions
End Preprocessor Options

Object modules:
     ! resolution-specific source codes
Atm144x90                  ! horizontal resolution is 144x90 -> 2x2.5deg
AtmL40                      ! vertical resolution is 40 layers -> 0.1mb
DIAG_RES_F                          ! diagnostics
FFT144                              ! Fast Fourier Transform

IO_DRV                              ! new i/o

     ! GISS dynamics with gravity wave drag
ATMDYN MOMEN2ND                     ! atmospheric dynamics
QUS_DRV QUS3D                       ! advection of Q/tracers
STRATDYN STRAT_DIAG                 ! stratospheric dynamics (incl. gw drag)

#include "latlon_source_files"
#include "modelE4_source_files"
#include "hycom_source_files"

#include "ocarbon_cycle_oH_files"   

Components:
#include "E4_components_nc"    /* without "Ent" */
tracers Ent

Component Options:
OPTS_Ent = ONLINE=YES PS_MODEL=FBB    /* needed for "Ent" only */
OPTS_giss_LSM = USE_ENT=YES           /* needed for "Ent" only */
OPTS_dd2d = NC_IO=PNETCDF             /* Parallel NETCDF */

Data input files:
#include "IC_144x90_input_files"
#include "hycom_387x360_input_files"
!!!AIC=1JAN2232.rsfEhMF01           ! initial condition from Nick Tau's run (ISTART=5)
AIC=/discover/nobackup/projects/giss/prod_input_files/1JAN3051.rsfEh119c.nc

RVR=RD_modelE_Fa_1deghycom_may10.nc            ! river direction file
NAMERVR=RD_modelE_Fa_1deghycom_may10.names.txt ! named river outlets

#include "land144x90_input_files"
#include "rad_input_files"
#include "rad_144x90_input_files"

#include "ocarbon_cycle_input_files"

MSU_wts=MSU.RSS.weights.data      ! MSU-diag
REG=REG2X2.5                      ! special regions-diag

Label and Namelist:  (next 2 lines)
E4arobio_h (AR5 model + obio)


&&PARAMETERS
#include "dynamic_ocn_params"
init_flake=0

#include "sdragF40_params"
#include "gwdragF40_params"

! cond_scheme=2   ! newer conductance scheme (N. Kiang) ! not used with Ent

! Increasing U00a decreases the high cloud cover; increasing U00b decreases net rad at TOA
U00a=0.54      ! above 850mb w/o MC region; tune this first to get 30-35% high clouds
U00b=1.00      ! below 850mb and MC regions; then tune this to get rad.balance

WMUI_multiplier = 2.

PTLISO=15.       ! press(mb) above which rad. assumes isothermal layers
H2ObyCH4=1.      ! activates strat.H2O generated by CH4
KSOLAR=2         ! 2: use long annual mean file ; 1: use short monthly file

#include "atmCompos_1850_params"
madaer=3         ! 3: updated aerosols          ; 1: default sulfates/aerosols

DTsrc=1800.      ! cannot be changed after a run has been started
DT=225.
! parameters that control the Shapiro filter
DT_XUfilter=225. ! Shapiro filter on U in E-W direction; usually same as DT
DT_XVfilter=225. ! Shapiro filter on V in E-W direction; usually same as DT
DT_YVfilter=0.   ! Shapiro filter on V in N-S direction
DT_YUfilter=0.   ! Shapiro filter on U in N-S direction

NIsurf=2         ! (surf.interaction NIsurf times per physics time step)
NRAD=5           ! radiation (every NRAD'th physics time step)

#include "diag_params"

Nssw=48          ! until diurnal diags are fixed, Nssw has to be even
Ndisk=720

itest=-1         ! default is -1
jtest=-1         ! default is -1
iocnmx=2         ! default is 2
brntop=50.       ! default is 50.
brnbot=200.      ! default is 200.
diapyn=2.e-7     ! default is 2.e-7
diapyc=.2e-4     ! default is .2e-4
jerlv0=1         ! default is 1

!parameters that affect CO2 gas exchange
!!! atmCO2=368.6      !uatm for year 2000
!!! atmCO2=285.226           !uatm for new preindustrial runs
atmCO2=0.             !prognostic atmCO2
to_volume_MixRat=1    ! for tracer printout
!!!solFe=0.02            ! default iron solubility
solFe=0.05            ! enhanced iron solubility

&&END_PARAMETERS

 &INPUTZ
 YEARI=1850,MONTHI=1,DATEI=01,HOURI=00, ! pick IYEAR1=YEARI (default) or < YEARI
 YEARE=2001,MONTHE=1,DATEE=02,HOURE=00, KDIAG=13*0,
 ISTART=8,IRANDI=0, YEARE=1850,MONTHE=1,DATEE=02,HOURE=00,IWRITE=1,JWRITE=1,
/
